:- module posix__read.			% Copyright (C) 2002 YesLogic Pty. Ltd.

:- interface.

:- import_module posix__buffer.

% read(Fd, Buffer, Count, Res)
:- pred read(fd, pointer, int, posix__result(int), io, io).
:- mode read(in, in, in, out, di, uo) is det.

%--------------------------------------------------------------------%

:- implementation.

read(Fd, Buffer, Count, Res) -->
    read0(Fd, Buffer, Count, Read),
    ( if { Read < 0 } then
	errno(Error),
	{ Res = error(Error) }
    else
	{ Res = ok(Read) }
    ).

%--------------------------------------------------------------------%

% read0(Fd, Pointer, Count, Read)
:- pred read0(fd, pointer, int, int, io, io).
:- mode read0(in, in, in, out, di, uo) is det.

:- pragma foreign_proc(c,
	read0(Fd::in, Buffer::in, Count::in, Read::out, IO0::di, IO::uo),
	[will_not_call_mercury, thread_safe, promise_pure], "
    Read = read(Fd, Buffer, Count);
    IO = IO0;
").

%--------------------------------------------------------------------%

:- end_module posix__read.

