:- module posix__syslog.		% Copyright (C) 2002 YesLogic Pty. Ltd.

:- interface.

% openlog(Ident)
:- pred openlog(string, io, io).
:- mode openlog(in, di, uo) is det.

% syslog(Message)
:- pred syslog(string, io, io).
:- mode syslog(in, di, uo) is det.

%--------------------------------------------------------------------%

:- implementation.

:- pragma foreign_decl(c, "
    #include <syslog.h>
").

:- pragma foreign_proc(c, openlog(Ident::in, IO0::di, IO::uo),
	[will_not_call_mercury, promise_pure], "
    openlog(Ident, 0, LOG_USER);
    IO = IO0;
").

:- pragma foreign_proc(c, syslog(Message::in, IO0::di, IO::uo),
	[will_not_call_mercury, promise_pure], "
    syslog(LOG_ERR, ""%s"", Message);
    IO = IO0;
").

%--------------------------------------------------------------------%

:- end_module posix__syslog.

