:- module posix__write.			% Copyright (C) 2002 YesLogic Pty. Ltd.

:- interface.

:- import_module posix__buffer.

% write(Fd, Buffer, Count, Res)
:- pred write(fd, pointer, int, posix__result(int), io, io).
:- mode write(in, in, in, out, di, uo) is det.

%--------------------------------------------------------------------%

:- implementation.

write(Fd, Buffer, Count, Res) -->
    write0(Fd, Buffer, Count, Written),
    ( if { Written < 0 } then
	errno(Error),
	{ Res = error(Error) }
    else
	{ Res = ok(Written) }
    ).

%--------------------------------------------------------------------%

% write0(Fd, Pointer, Count, Written)
:- pred write0(fd, pointer, int, int, io, io).
:- mode write0(in, in, in, out, di, uo) is det.

:- pragma foreign_proc(c,
	write0(Fd::in, Buffer::in, Count::in, Written::out, IO0::di, IO::uo),
	[will_not_call_mercury, thread_safe, promise_pure], "
    Written = write(Fd, Buffer, Count);
    IO = IO0;
").

%--------------------------------------------------------------------%

:- end_module write.

