:- module util.

:- interface.

:- import_module string, int, io, stream.

:- pred read_int(In, string, int, io, io) <= putback(In).
:- mode read_int(in, in, out, di, uo) is det.

:- pred io_result(string, stream__result(T), T).
:- mode io_result(in, in, out) is det.

:- implementation.

:- import_module require, list.

read_int(In, Msg, Int, !IO) :-
    read_word(In, Res0, !IO), io_result(Msg, Res0, Int0),
    ( if to_int(from_char_list(Int0), Int1) then
	Int = Int1
    else
	error(Msg++" is not integer")
    ).

io_result(Msg, Res, T) :-
    (
	Res = ok(T)
    ;
	Res = eof, error("eof reading " ++ Msg)
    ;
	Res = error(Error),
	error("error reading " ++ Msg ++ ": " ++ Error)
    ).

